<?xml version="1.0" encoding="UTF-8" ?>
<!DOCTYPE mapper
        PUBLIC "-//mybatis.org//DTD Mapper 3.0//EN"
        "http://mybatis.org/dtd/mybatis-3-mapper.dtd">
<mapper namespace="com.xzzn.ems.mapper.EmsMqttTopicConfigMapper">

    <resultMap type="EmsMqttTopicConfig" id="EmsMqttTopicConfigResult">
        <result property="id"    column="id"    />
        <result property="mqttTopic"    column="mqtt_topic"    />
        <result property="qos"    column="qos"    />
        <result property="topicName"    column="topic_name"    />
        <result property="handleMethod"    column="handle_method"    />
        <result property="handleType"    column="handle_type"    />
        <result property="siteId"    column="siteId"    />
        <result property="createBy"    column="create_by"    />
        <result property="createTime"    column="create_time"    />
        <result property="updateBy"    column="update_by"    />
        <result property="updateTime"    column="update_time"    />
    </resultMap>

    <sql id="selectEmsMqttTopicConfigVo">
        select id, mqtt_topic, qos, topic_name, handle_method, handle_type, siteId, create_by, create_time, update_by, update_time from ems_mqtt_topic_config
    </sql>

    <select id="selectEmsMqttTopicConfigList" parameterType="EmsMqttTopicConfig" resultMap="EmsMqttTopicConfigResult">
        <include refid="selectEmsMqttTopicConfigVo"/>
        <where>
            <if test="mqttTopic != null  and mqttTopic != ''"> and mqtt_topic = #{mqttTopic}</if>
            <if test="qos != null "> and qos = #{qos}</if>
            <if test="topicName != null  and topicName != ''"> and topic_name like concat('%', #{topicName}, '%')</if>
            <if test="handleMethod != null  and handleMethod != ''"> and handle_method = #{handleMethod}</if>
            <if test="handleType != null  and handleType != ''"> and handle_type = #{handleType}</if>
            <if test="siteId != null  and siteId != ''"> and siteId = #{siteId}</if>
        </where>
    </select>

    <select id="selectEmsMqttTopicConfigById" parameterType="Long" resultMap="EmsMqttTopicConfigResult">
        <include refid="selectEmsMqttTopicConfigVo"/>
        where id = #{id}
    </select>

    <insert id="insertEmsMqttTopicConfig" parameterType="EmsMqttTopicConfig" useGeneratedKeys="true" keyProperty="id">
        insert into ems_mqtt_topic_config
        <trim prefix="(" suffix=")" suffixOverrides=",">
            <if test="mqttTopic != null">mqtt_topic,</if>
            <if test="qos != null">qos,</if>
            <if test="topicName != null">topic_name,</if>
            <if test="handleMethod != null">handle_method,</if>
            <if test="handleType != null">handle_type,</if>
            <if test="siteId != null">siteId,</if>
            <if test="createBy != null">create_by,</if>
            <if test="createTime != null">create_time,</if>
            <if test="updateBy != null">update_by,</if>
            <if test="updateTime != null">update_time,</if>
        </trim>
        <trim prefix="values (" suffix=")" suffixOverrides=",">
            <if test="mqttTopic != null">#{mqttTopic},</if>
            <if test="qos != null">#{qos},</if>
            <if test="topicName != null">#{topicName},</if>
            <if test="handleMethod != null">#{handleMethod},</if>
            <if test="handleType != null">#{handleType},</if>
            <if test="siteId != null">#{siteId},</if>
            <if test="createBy != null">#{createBy},</if>
            <if test="createTime != null">#{createTime},</if>
            <if test="updateBy != null">#{updateBy},</if>
            <if test="updateTime != null">#{updateTime},</if>
        </trim>
    </insert>

    <update id="updateEmsMqttTopicConfig" parameterType="EmsMqttTopicConfig">
        update ems_mqtt_topic_config
        <trim prefix="SET" suffixOverrides=",">
            <if test="mqttTopic != null">mqtt_topic = #{mqttTopic},</if>
            <if test="qos != null">qos = #{qos},</if>
            <if test="topicName != null">topic_name = #{topicName},</if>
            <if test="handleMethod != null">handle_method = #{handleMethod},</if>
            <if test="handleType != null">handle_type = #{handleType},</if>
            <if test="siteId != null">siteId = #{siteId},</if>
            <if test="createBy != null">create_by = #{createBy},</if>
            <if test="createTime != null">create_time = #{createTime},</if>
            <if test="updateBy != null">update_by = #{updateBy},</if>
            <if test="updateTime != null">update_time = #{updateTime},</if>
        </trim>
        where id = #{id}
    </update>

    <delete id="deleteEmsMqttTopicConfigById" parameterType="Long">
        delete from ems_mqtt_topic_config where id = #{id}
    </delete>

    <delete id="deleteEmsMqttTopicConfigByIds" parameterType="String">
        delete from ems_mqtt_topic_config where id in
        <foreach item="id" collection="array" open="(" separator="," close=")">
            #{id}
        </foreach>
    </delete>

    <select id="checkTopicIsExist" parameterType="String" resultType="String">
        select mqtt_topic as topic
        from ems_mqtt_topic_config
        where mqtt_topic = #{strategyTopic}
    </select>

    <select id="selectOneByTopic" parameterType="String" resultMap="EmsMqttTopicConfigResult">
        <include refid="selectEmsMqttTopicConfigVo"/>
        where mqtt_topic = #{topic}
    </select>
</mapper>